| LUFA Library 140302 |

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Data Structures | Macros | Enumerations | Functions
Android Open Accessory Class Host Mode Driver
Android Open Accessory Class Driver

## Data Structures
struct | USB_ClassInfo_AOA_Host_t
| Android Open Accessory Class Host Mode Configuration and State Structure. More...

## Macros
#define | AOA_ERROR_LOGICAL_CMD_FAILED 0x80

## Enumerations
enum | AOA_Host_EnumerationFailure_ErrorCodes_t { AOA_ENUMERROR_NoError = 0, AOA_ENUMERROR_InvalidConfigDescriptor = 1, AOA_ENUMERROR_NoCompatibleInterfaceFound = 2, AOA_ENUMERROR_PipeConfigurationFailed = 3 }

## Functions
uint16_t | AOA_Host_BytesReceived (USB_ClassInfo_AOA_Host_t *const AOAInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | AOA_Host_ConfigurePipes (USB_ClassInfo_AOA_Host_t *const AOAInterfaceInfo, uint16_t ConfigDescriptorSize, void *ConfigDescriptorData) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(3)
void | AOA_Host_CreateBlockingStream (USB_ClassInfo_AOA_Host_t *const AOAInterfaceInfo, FILE *const Stream) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
void | AOA_Host_CreateStream (USB_ClassInfo_AOA_Host_t *const AOAInterfaceInfo, FILE *const Stream) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
uint8_t | AOA_Host_Flush (USB_ClassInfo_AOA_Host_t *const AOAInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
int16_t | AOA_Host_ReceiveByte (USB_ClassInfo_AOA_Host_t *const AOAInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | AOA_Host_SendByte (USB_ClassInfo_AOA_Host_t *const AOAInterfaceInfo, const uint8_t Data) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | AOA_Host_SendData (USB_ClassInfo_AOA_Host_t *const AOAInterfaceInfo, const void *const Buffer, const uint16_t Length) ATTR_NON_NULL_PTR_ARG(1)
uint8_t | AOA_Host_SendString (USB_ClassInfo_AOA_Host_t *const AOAInterfaceInfo, const char *const String) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2)
uint8_t | AOA_Host_StartAccessoryMode (USB_ClassInfo_AOA_Host_t *const AOAInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
void | AOA_Host_USBTask (USB_ClassInfo_AOA_Host_t *const AOAInterfaceInfo) ATTR_NON_NULL_PTR_ARG(1)
bool | AOA_Host_ValidateAccessoryDevice (USB_ClassInfo_AOA_Host_t *const AOAInterfaceInfo, const USB_Descriptor_Device_t *const DeviceDescriptor, bool *const NeedModeSwitch) ATTR_NON_NULL_PTR_ARG(1) ATTR_NON_NULL_PTR_ARG(2) ATTR_NON_NULL_PTR_ARG(3)

## Detailed Description

# Module Source Dependencies

The following files must be built with any user project that uses this module:

- LUFA/Drivers/USB/Class/Host/AndroidAccessoryClassHost.c (Makefile source module name: LUFA_SRC_USBCLASS)

# Module Description

Host Mode USB Class driver framework interface, for the Android Open Accessory USB Class driver.

## Macro Definition Documentation

#define AOA_ERROR_LOGICAL_CMD_FAILED 0x80

Error code for some Android Open Accessory Host functions, indicating a logical (and not hardware) error.

## Enumeration Type Documentation

enum AOA_Host_EnumerationFailure_ErrorCodes_t

Enum for the possible error codes returned by the AOA_Host_ConfigurePipes() function.

Enumerator
AOA_ENUMERROR_NoError | Configuration Descriptor was processed successfully.
AOA_ENUMERROR_InvalidConfigDescriptor | The device returned an invalid Configuration Descriptor.
AOA_ENUMERROR_NoCompatibleInterfaceFound | A compatible Android Open Accessory interface was not found in the device's Configuration Descriptor.
AOA_ENUMERROR_PipeConfigurationFailed | One or more pipes for the specified interface could not be configured correctly.

## Function Documentation

uint16_t AOA_Host_BytesReceived | ( | USB_ClassInfo_AOA_Host_t *const | AOAInterfaceInfo | ) |

Determines the number of bytes received by the AOA interface from the device, waiting to be read. This indicates the number of bytes in the IN pipe bank only, and thus the number of calls to AOA_Host_ReceiveByte() which are guaranteed to succeed immediately. If multiple bytes are to be received, they should be buffered by the user application, as the pipe bank will not be released back to the USB controller until all bytes are read.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  [in,out] | AOAInterfaceInfo | Pointer to a structure containing a AOA Class host configuration and state.

Returns
  Total number of buffered bytes received from the device.

uint8_t AOA_Host_ConfigurePipes | ( | USB_ClassInfo_AOA_Host_t *const | AOAInterfaceInfo,
|  | uint16_t | ConfigDescriptorSize,
|  | void * | ConfigDescriptorData
| ) |  |

Host interface configuration routine, to configure a given Android Open Accessory host interface instance using the Configuration Descriptor read from an attached USB device. This function automatically updates the given Android Open Accessory Host instance's state values and configures the pipes required to communicate with the interface if it is found within the device. This should be called once after the stack has enumerated the attached device, while the host state machine is in the Addressed state.

Parameters

  [in,out] | AOAInterfaceInfo | Pointer to a structure containing an AOA Class host configuration and state.
  [in] | ConfigDescriptorSize | Length of the attached device's Configuration Descriptor.
  [in] | ConfigDescriptorData | Pointer to a buffer containing the attached device's Configuration Descriptor.

Returns
  A value from the AOA_Host_EnumerationFailure_ErrorCodes_t enum.

void AOA_Host_CreateBlockingStream | ( | USB_ClassInfo_AOA_Host_t *const | AOAInterfaceInfo,
|  | FILE *const | Stream
| ) |  |

Identical to AOA_Host_CreateStream(), except that reads are blocking until the calling stream function terminates the transfer. While blocking, the USB and AOA service tasks are called repeatedly to maintain USB communications.

Note
  This function is not available on all microcontroller architectures.

Parameters

  [in,out] | AOAInterfaceInfo | Pointer to a structure containing a AOA Class configuration and state.
  [in,out] | Stream | Pointer to a FILE structure where the created stream should be placed.

void AOA_Host_CreateStream | ( | USB_ClassInfo_AOA_Host_t *const | AOAInterfaceInfo,
|  | FILE *const | Stream
| ) |  |

Creates a standard character stream for the given AOA Device instance so that it can be used with all the regular functions in the standard `<stdio.h>` library that accept a `FILE` stream as a destination (e.g. `fprintf`). The created stream is bidirectional and can be used for both input and output functions.

Reading data from this stream is non-blocking, i.e. in most instances, complete strings cannot be read in by a single fetch, as the endpoint will not be ready at some point in the transmission, aborting the transfer. However, this may be used when the read data is processed byte-per-bye (via `getc()`) or when the user application will implement its own line buffering.

Note
  The created stream can be given as `stdout` if desired to direct the standard output from all `<stdio.h>` functions to the given AOA interface.
  This function is not available on all microcontroller architectures.

Parameters

  [in,out] | AOAInterfaceInfo | Pointer to a structure containing a AOA Class configuration and state.
  [in,out] | Stream | Pointer to a FILE structure where the created stream should be placed.

uint8_t AOA_Host_Flush | ( | USB_ClassInfo_AOA_Host_t *const | AOAInterfaceInfo | ) |

Flushes any data waiting to be sent, ensuring that the send buffer is cleared.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  [in,out] | AOAInterfaceInfo | Pointer to a structure containing a AOA Class host configuration and state.

Returns
  A value from the Pipe_WaitUntilReady_ErrorCodes_t enum.

int16_t AOA_Host_ReceiveByte | ( | USB_ClassInfo_AOA_Host_t *const | AOAInterfaceInfo | ) |

Reads a byte of data from the device. If no data is waiting to be read of if a USB device is not connected, the function returns a negative value. The AOA_Host_BytesReceived() function may be queried in advance to determine how many bytes are currently buffered in the AOA interface's data receive pipe.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  [in,out] | AOAInterfaceInfo | Pointer to a structure containing a AOA Class host configuration and state.

Returns
  Next received byte from the device, or a negative value if no data received.

uint8_t AOA_Host_SendByte | ( | USB_ClassInfo_AOA_Host_t *const | AOAInterfaceInfo,
|  | const uint8_t | Data
| ) |  |

Sends a given byte to the attached USB device, if connected. If a device is not connected when the function is called, the byte is discarded. Bytes will be queued for transmission to the device until either the pipe bank becomes full, or the AOA_Host_Flush() function is called to flush the pending data to the host. This allows for multiple bytes to be packed into a single pipe packet, increasing data throughput.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  [in,out] | AOAInterfaceInfo | Pointer to a structure containing a AOA Class host configuration and state.
  [in] | Data | Byte of data to send to the device.

Returns
  A value from the Pipe_WaitUntilReady_ErrorCodes_t enum.

uint8_t AOA_Host_SendData | ( | USB_ClassInfo_AOA_Host_t *const | AOAInterfaceInfo,
|  | const void *const | Buffer,
|  | const uint16_t | Length
| ) |  |

Sends a given data buffer to the attached USB device, if connected. If a device is not connected when the function is called, the data will be discarded. Bytes will be queued for transmission to the device until either the pipe bank becomes full, or the AOA_Host_Flush() function is called to flush the pending data to the device. This allows for multiple bytes to be packed into a single pipe packet, increasing data throughput.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  [in,out] | AOAInterfaceInfo | Pointer to a structure containing a AOA Class host configuration and state.
  [in] | Buffer | Pointer to a buffer containing the data to send to the device.
  [in] | Length | Length of the data to send to the device.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum.

uint8_t AOA_Host_SendString | ( | USB_ClassInfo_AOA_Host_t *const | AOAInterfaceInfo,
|  | const char *const | String
| ) |  |

Sends a given null-terminated string to the attached USB device, if connected. If a device is not connected when the function is called, the string is discarded. Bytes will be queued for transmission to the device until either the pipe bank becomes full, or the AOA_Host_Flush() function is called to flush the pending data to the device. This allows for multiple bytes to be packed into a single pipe packet, increasing data throughput.

Precondition
  This function must only be called when the Host state machine is in the HOST_STATE_Configured state or the call will fail.

Parameters

  [in,out] | AOAInterfaceInfo | Pointer to a structure containing a AOA Class host configuration and state.
  [in] | String | Pointer to the null terminated string to send to the device.

Returns
  A value from the Pipe_Stream_RW_ErrorCodes_t enum.

uint8_t AOA_Host_StartAccessoryMode | ( | USB_ClassInfo_AOA_Host_t *const | AOAInterfaceInfo | ) |

Starts Accessory Mode in the attached Android device. This function will validate the device's Android Open Accessory protocol version, send the configured property strings, and request a switch to Android Open Accessory mode.

Parameters

  [in,out] | AOAInterfaceInfo | Pointer to a structure containing an AOA Class host configuration and state.

Returns
  A value from the USB_Host_SendControlErrorCodes_t enum, or AOA_ERROR_LOGICAL_CMD_FAILED if a logical error occurred..

void AOA_Host_USBTask | ( | USB_ClassInfo_AOA_Host_t *const | AOAInterfaceInfo | ) |

General management task for a given Android Open Accessory host class interface, required for the correct operation of the interface. This should be called frequently in the main program loop, before the master USB management task USB_USBTask().

Parameters

  [in,out] | AOAInterfaceInfo | Pointer to a structure containing an Android Open Accessory Class host configuration and state.

bool AOA_Host_ValidateAccessoryDevice | ( | USB_ClassInfo_AOA_Host_t *const | AOAInterfaceInfo,
|  | const USB_Descriptor_Device_t *const | DeviceDescriptor,
|  | bool *const | NeedModeSwitch
| ) |  |

Validates a device descriptor, to check if the device is a valid Android device, and if it is currently in Android Open Accessory mode.

Parameters

  [in,out] | AOAInterfaceInfo | Pointer to a structure containing an AOA Class host configuration and state.
  [in] | DeviceDescriptor | Pointer a buffer containing the attached device's Device Descriptor.
  [out] | NeedModeSwitch | Pointer to a boolean where the mode switch requirement of the attached device is to be stored.

Returns
  Boolean `true` if the attached device is a valid Android device, `false` otherwise.